/* DBusAccelerator.c generated by valac 0.46.1, the Vala compiler
 * generated from DBusAccelerator.vala, do not modify */

/* 
 * Copyright 2015 Nicolas Bruguier, Corentin Noël
 * Copyright 2018 elementary LLC. (https://elementary.io)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	GREETER_COMPOSITOR_ACTION_MODE_NONE = 0,
	GREETER_COMPOSITOR_ACTION_MODE_NORMAL = 1 << 0,
	GREETER_COMPOSITOR_ACTION_MODE_OVERVIEW = 1 << 1,
	GREETER_COMPOSITOR_ACTION_MODE_LOCK_SCREEN = 1 << 2,
	GREETER_COMPOSITOR_ACTION_MODE_UNLOCK_SCREEN = 1 << 3,
	GREETER_COMPOSITOR_ACTION_MODE_LOGIN_SCREEN = 1 << 4,
	GREETER_COMPOSITOR_ACTION_MODE_SYSTEM_MODAL = 1 << 5,
	GREETER_COMPOSITOR_ACTION_MODE_LOOKING_GLASS = 1 << 6,
	GREETER_COMPOSITOR_ACTION_MODE_POPUP = 1 << 7
} GreeterCompositorActionMode;

#define GREETER_COMPOSITOR_TYPE_ACTION_MODE (greeter_compositor_action_mode_get_type ())

#define GREETER_COMPOSITOR_TYPE_ACCELERATOR (greeter_compositor_accelerator_get_type ())
typedef struct _GreeterCompositorAccelerator GreeterCompositorAccelerator;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GreeterCompositorGrabbedAccelerator GreeterCompositorGrabbedAccelerator;

#define GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR (greeter_compositor_dbus_accelerator_get_type ())
#define GREETER_COMPOSITOR_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR, GreeterCompositorDBusAccelerator))
#define GREETER_COMPOSITOR_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR, GreeterCompositorDBusAcceleratorClass))
#define GREETER_COMPOSITOR_IS_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR))
#define GREETER_COMPOSITOR_IS_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR))
#define GREETER_COMPOSITOR_DBUS_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR, GreeterCompositorDBusAcceleratorClass))

typedef struct _GreeterCompositorDBusAccelerator GreeterCompositorDBusAccelerator;
typedef struct _GreeterCompositorDBusAcceleratorClass GreeterCompositorDBusAcceleratorClass;
typedef struct _GreeterCompositorDBusAcceleratorPrivate GreeterCompositorDBusAcceleratorPrivate;

#define GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER (greeter_compositor_window_manager_get_type ())
#define GREETER_COMPOSITOR_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER, GreeterCompositorWindowManager))
#define GREETER_COMPOSITOR_WINDOW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER, GreeterCompositorWindowManagerClass))
#define GREETER_COMPOSITOR_IS_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER))
#define GREETER_COMPOSITOR_IS_WINDOW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER))
#define GREETER_COMPOSITOR_WINDOW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER, GreeterCompositorWindowManagerClass))

typedef struct _GreeterCompositorWindowManager GreeterCompositorWindowManager;
typedef struct _GreeterCompositorWindowManagerClass GreeterCompositorWindowManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _greeter_compositor_dbus_accelerator_unref0(var) ((var == NULL) ? NULL : (var = (greeter_compositor_dbus_accelerator_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _greeter_compositor_grabbed_accelerator_free0(var) ((var == NULL) ? NULL : (var = (greeter_compositor_grabbed_accelerator_free (var), NULL)))
typedef struct _GreeterCompositorParamSpecDBusAccelerator GreeterCompositorParamSpecDBusAccelerator;
enum  {
	GREETER_COMPOSITOR_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL,
	GREETER_COMPOSITOR_DBUS_ACCELERATOR_NUM_SIGNALS
};
static guint greeter_compositor_dbus_accelerator_signals[GREETER_COMPOSITOR_DBUS_ACCELERATOR_NUM_SIGNALS] = {0};

struct _GreeterCompositorAccelerator {
	gchar* name;
	GreeterCompositorActionMode flags;
};

struct _GreeterCompositorGrabbedAccelerator {
	GreeterCompositorAccelerator accelerator;
	guint action;
};

struct _GreeterCompositorDBusAccelerator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GreeterCompositorDBusAcceleratorPrivate * priv;
};

struct _GreeterCompositorDBusAcceleratorClass {
	GTypeClass parent_class;
	void (*finalize) (GreeterCompositorDBusAccelerator *self);
};

struct _GreeterCompositorDBusAcceleratorPrivate {
	GreeterCompositorWindowManager* wm;
	GList* grabbed_accelerators;
};

struct _GreeterCompositorParamSpecDBusAccelerator {
	GParamSpec parent_instance;
};

static gint GreeterCompositorDBusAccelerator_private_offset;
static gpointer greeter_compositor_dbus_accelerator_parent_class = NULL;
static GreeterCompositorDBusAccelerator* greeter_compositor_dbus_accelerator_instance;
static GreeterCompositorDBusAccelerator* greeter_compositor_dbus_accelerator_instance = NULL;

GType greeter_compositor_action_mode_get_type (void) G_GNUC_CONST;
GType greeter_compositor_accelerator_get_type (void) G_GNUC_CONST;
GreeterCompositorAccelerator* greeter_compositor_accelerator_dup (const GreeterCompositorAccelerator* self);
void greeter_compositor_accelerator_free (GreeterCompositorAccelerator* self);
void greeter_compositor_accelerator_copy (const GreeterCompositorAccelerator* self,
                                          GreeterCompositorAccelerator* dest);
void greeter_compositor_accelerator_destroy (GreeterCompositorAccelerator* self);
void greeter_compositor_grabbed_accelerator_free (GreeterCompositorGrabbedAccelerator * self);
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorGrabbedAccelerator, greeter_compositor_grabbed_accelerator_free)
static void greeter_compositor_grabbed_accelerator_instance_init (GreeterCompositorGrabbedAccelerator * self);
GreeterCompositorGrabbedAccelerator* greeter_compositor_grabbed_accelerator_new (void);
gpointer greeter_compositor_dbus_accelerator_ref (gpointer instance);
void greeter_compositor_dbus_accelerator_unref (gpointer instance);
GParamSpec* greeter_compositor_param_spec_dbus_accelerator (const gchar* name,
                                                            const gchar* nick,
                                                            const gchar* blurb,
                                                            GType object_type,
                                                            GParamFlags flags);
void greeter_compositor_value_set_dbus_accelerator (GValue* value,
                                                    gpointer v_object);
void greeter_compositor_value_take_dbus_accelerator (GValue* value,
                                                     gpointer v_object);
gpointer greeter_compositor_value_get_dbus_accelerator (const GValue* value);
GType greeter_compositor_dbus_accelerator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorDBusAccelerator, greeter_compositor_dbus_accelerator_unref)
guint greeter_compositor_dbus_accelerator_register_object (void* object,
                                                           GDBusConnection* connection,
                                                           const gchar* path,
                                                           GError** error);
GType greeter_compositor_window_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorWindowManager, g_object_unref)
static void _greeter_compositor_grabbed_accelerator_free0_ (gpointer var);
static inline void _g_list_free__greeter_compositor_grabbed_accelerator_free0_ (GList* self);
GreeterCompositorDBusAccelerator* greeter_compositor_dbus_accelerator_init (GreeterCompositorWindowManager* wm);
static GreeterCompositorDBusAccelerator* greeter_compositor_dbus_accelerator_new (GreeterCompositorWindowManager* _wm);
static GreeterCompositorDBusAccelerator* greeter_compositor_dbus_accelerator_construct (GType object_type,
                                                                                 GreeterCompositorWindowManager* _wm);
static void greeter_compositor_dbus_accelerator_on_accelerator_activated (GreeterCompositorDBusAccelerator* self,
                                                                   guint action,
                                                                   guint device_id,
                                                                   guint timestamp);
static void _greeter_compositor_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                                       guint object,
                                                                                                       guint p0,
                                                                                                       guint p1,
                                                                                                       gpointer self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static guint greeter_compositor_dbus_accelerator_grab_accelerator (GreeterCompositorDBusAccelerator* self,
                                                            GreeterCompositorAccelerator* accelerator);
guint* greeter_compositor_dbus_accelerator_grab_accelerators (GreeterCompositorDBusAccelerator* self,
                                                              GreeterCompositorAccelerator* accelerators,
                                                              gint accelerators_length1,
                                                              gint* result_length1,
                                                              GError** error);
static void _vala_array_add1 (guint* * array,
                       int* length,
                       int* size,
                       guint value);
gboolean greeter_compositor_dbus_accelerator_ungrab_accelerator (GreeterCompositorDBusAccelerator* self,
                                                                 guint action,
                                                                 GError** error);
void greeter_compositor_dbus_accelerator_show_osd (GreeterCompositorDBusAccelerator* self,
                                                   GHashTable* parameters,
                                                   GError** error);
void greeter_compositor_media_feedback_send (const gchar* icon,
                                             gint val);
static void g_cclosure_user_marshal_VOID__UINT_BOXED (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void greeter_compositor_dbus_accelerator_finalize (GreeterCompositorDBusAccelerator * obj);
static void _vala_GreeterCompositorAccelerator_array_free (GreeterCompositorAccelerator * array,
                                                    gint array_length);
static void _dbus_greeter_compositor_dbus_accelerator_grab_accelerators (GreeterCompositorDBusAccelerator* self,
                                                                  GVariant* _parameters_,
                                                                  GDBusMethodInvocation* invocation);
static void _dbus_greeter_compositor_dbus_accelerator_ungrab_accelerator (GreeterCompositorDBusAccelerator* self,
                                                                   GVariant* _parameters_,
                                                                   GDBusMethodInvocation* invocation);
static void _dbus_greeter_compositor_dbus_accelerator_show_osd (GreeterCompositorDBusAccelerator* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void greeter_compositor_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                                     const gchar* sender,
                                                                     const gchar* object_path,
                                                                     const gchar* interface_name,
                                                                     const gchar* method_name,
                                                                     GVariant* parameters,
                                                                     GDBusMethodInvocation* invocation,
                                                                     gpointer user_data);
static GVariant* greeter_compositor_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                                           const gchar* sender,
                                                                           const gchar* object_path,
                                                                           const gchar* interface_name,
                                                                           const gchar* property_name,
                                                                           GError** error,
                                                                           gpointer user_data);
static gboolean greeter_compositor_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                                          const gchar* sender,
                                                                          const gchar* object_path,
                                                                          const gchar* interface_name,
                                                                          const gchar* property_name,
                                                                          GVariant* value,
                                                                          GError** error,
                                                                          gpointer user_data);
static void _dbus_greeter_compositor_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                                      guint action,
                                                                      GHashTable* parameters,
                                                                      gpointer* _data);
static void _greeter_compositor_dbus_accelerator_unregister_object (gpointer user_data);

static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators = {-1, "accelerators", "a(su)", NULL};
static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_result = {-1, "result", "au", NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_in[] = {&_greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators, NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_out[] = {&_greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_result, NULL};
static const GDBusMethodInfo _greeter_compositor_dbus_accelerator_dbus_method_info_grab_accelerators = {-1, "GrabAccelerators", (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_in), (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_grab_accelerators_out), NULL};
static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action = {-1, "action", "u", NULL};
static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in[] = {&_greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action, NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out[] = {&_greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result, NULL};
static const GDBusMethodInfo _greeter_compositor_dbus_accelerator_dbus_method_info_ungrab_accelerator = {-1, "UngrabAccelerator", (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in), (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out), NULL};
static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_show_osd_parameters = {-1, "parameters", "a{sv}", NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_show_osd_in[] = {&_greeter_compositor_dbus_accelerator_dbus_arg_info_show_osd_parameters, NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_show_osd_out[] = {NULL};
static const GDBusMethodInfo _greeter_compositor_dbus_accelerator_dbus_method_info_show_osd = {-1, "ShowOSD", (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_show_osd_in), (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_show_osd_out), NULL};
static const GDBusMethodInfo * const _greeter_compositor_dbus_accelerator_dbus_method_info[] = {&_greeter_compositor_dbus_accelerator_dbus_method_info_grab_accelerators, &_greeter_compositor_dbus_accelerator_dbus_method_info_ungrab_accelerator, &_greeter_compositor_dbus_accelerator_dbus_method_info_show_osd, NULL};
static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_accelerator_activated_action = {-1, "action", "u", NULL};
static const GDBusArgInfo _greeter_compositor_dbus_accelerator_dbus_arg_info_accelerator_activated_parameters = {-1, "parameters", "a{sv}", NULL};
static const GDBusArgInfo * const _greeter_compositor_dbus_accelerator_dbus_arg_info_accelerator_activated[] = {&_greeter_compositor_dbus_accelerator_dbus_arg_info_accelerator_activated_action, &_greeter_compositor_dbus_accelerator_dbus_arg_info_accelerator_activated_parameters, NULL};
static const GDBusSignalInfo _greeter_compositor_dbus_accelerator_dbus_signal_info_accelerator_activated = {-1, "AcceleratorActivated", (GDBusArgInfo **) (&_greeter_compositor_dbus_accelerator_dbus_arg_info_accelerator_activated), NULL};
static const GDBusSignalInfo * const _greeter_compositor_dbus_accelerator_dbus_signal_info[] = {&_greeter_compositor_dbus_accelerator_dbus_signal_info_accelerator_activated, NULL};
static const GDBusPropertyInfo * const _greeter_compositor_dbus_accelerator_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _greeter_compositor_dbus_accelerator_dbus_interface_info = {-1, "org.gnome.Shell", (GDBusMethodInfo **) (&_greeter_compositor_dbus_accelerator_dbus_method_info), (GDBusSignalInfo **) (&_greeter_compositor_dbus_accelerator_dbus_signal_info), (GDBusPropertyInfo **) (&_greeter_compositor_dbus_accelerator_dbus_property_info), NULL};
static const GDBusInterfaceVTable _greeter_compositor_dbus_accelerator_dbus_interface_vtable = {greeter_compositor_dbus_accelerator_dbus_interface_method_call, greeter_compositor_dbus_accelerator_dbus_interface_get_property, greeter_compositor_dbus_accelerator_dbus_interface_set_property};

/**
     * ActionMode:
     * @NONE: block action
     * @NORMAL: allow action when in window mode, e.g. when the focus is in an application window
     * @OVERVIEW: allow action while the overview is active
     * @LOCK_SCREEN: allow action when the screen is locked, e.g. when the screen shield is shown
     * @UNLOCK_SCREEN: allow action in the unlock dialog
     * @LOGIN_SCREEN: allow action in the login screen
     * @SYSTEM_MODAL: allow action when a system modal dialog (e.g. authentification or session dialogs) is open
     * @LOOKING_GLASS: allow action in looking glass
     * @POPUP: allow action while a shell menu is open
     */
GType
greeter_compositor_action_mode_get_type (void)
{
	static volatile gsize greeter_compositor_action_mode_type_id__volatile = 0;
	if (g_once_init_enter (&greeter_compositor_action_mode_type_id__volatile)) {
		static const GFlagsValue values[] = {{GREETER_COMPOSITOR_ACTION_MODE_NONE, "GREETER_COMPOSITOR_ACTION_MODE_NONE", "none"}, {GREETER_COMPOSITOR_ACTION_MODE_NORMAL, "GREETER_COMPOSITOR_ACTION_MODE_NORMAL", "normal"}, {GREETER_COMPOSITOR_ACTION_MODE_OVERVIEW, "GREETER_COMPOSITOR_ACTION_MODE_OVERVIEW", "overview"}, {GREETER_COMPOSITOR_ACTION_MODE_LOCK_SCREEN, "GREETER_COMPOSITOR_ACTION_MODE_LOCK_SCREEN", "lock-screen"}, {GREETER_COMPOSITOR_ACTION_MODE_UNLOCK_SCREEN, "GREETER_COMPOSITOR_ACTION_MODE_UNLOCK_SCREEN", "unlock-screen"}, {GREETER_COMPOSITOR_ACTION_MODE_LOGIN_SCREEN, "GREETER_COMPOSITOR_ACTION_MODE_LOGIN_SCREEN", "login-screen"}, {GREETER_COMPOSITOR_ACTION_MODE_SYSTEM_MODAL, "GREETER_COMPOSITOR_ACTION_MODE_SYSTEM_MODAL", "system-modal"}, {GREETER_COMPOSITOR_ACTION_MODE_LOOKING_GLASS, "GREETER_COMPOSITOR_ACTION_MODE_LOOKING_GLASS", "looking-glass"}, {GREETER_COMPOSITOR_ACTION_MODE_POPUP, "GREETER_COMPOSITOR_ACTION_MODE_POPUP", "popup"}, {0, NULL, NULL}};
		GType greeter_compositor_action_mode_type_id;
		greeter_compositor_action_mode_type_id = g_flags_register_static ("GreeterCompositorActionMode", values);
		g_once_init_leave (&greeter_compositor_action_mode_type_id__volatile, greeter_compositor_action_mode_type_id);
	}
	return greeter_compositor_action_mode_type_id__volatile;
}

void
greeter_compositor_accelerator_copy (const GreeterCompositorAccelerator* self,
                                     GreeterCompositorAccelerator* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GreeterCompositorActionMode _tmp2_;
#line 45 "../compositor/DBusAccelerator.vala"
	_tmp0_ = (*self).name;
#line 45 "../compositor/DBusAccelerator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 45 "../compositor/DBusAccelerator.vala"
	_g_free0 ((*dest).name);
#line 45 "../compositor/DBusAccelerator.vala"
	(*dest).name = _tmp1_;
#line 45 "../compositor/DBusAccelerator.vala"
	_tmp2_ = (*self).flags;
#line 45 "../compositor/DBusAccelerator.vala"
	(*dest).flags = _tmp2_;
#line 300 "DBusAccelerator.c"
}

void
greeter_compositor_accelerator_destroy (GreeterCompositorAccelerator* self)
{
#line 46 "../compositor/DBusAccelerator.vala"
	_g_free0 ((*self).name);
#line 308 "DBusAccelerator.c"
}

GreeterCompositorAccelerator*
greeter_compositor_accelerator_dup (const GreeterCompositorAccelerator* self)
{
	GreeterCompositorAccelerator* dup;
#line 45 "../compositor/DBusAccelerator.vala"
	dup = g_new0 (GreeterCompositorAccelerator, 1);
#line 45 "../compositor/DBusAccelerator.vala"
	greeter_compositor_accelerator_copy (self, dup);
#line 45 "../compositor/DBusAccelerator.vala"
	return dup;
#line 321 "DBusAccelerator.c"
}

void
greeter_compositor_accelerator_free (GreeterCompositorAccelerator* self)
{
#line 45 "../compositor/DBusAccelerator.vala"
	greeter_compositor_accelerator_destroy (self);
#line 45 "../compositor/DBusAccelerator.vala"
	g_free (self);
#line 331 "DBusAccelerator.c"
}

GType
greeter_compositor_accelerator_get_type (void)
{
	static volatile gsize greeter_compositor_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&greeter_compositor_accelerator_type_id__volatile)) {
		GType greeter_compositor_accelerator_type_id;
		greeter_compositor_accelerator_type_id = g_boxed_type_register_static ("GreeterCompositorAccelerator", (GBoxedCopyFunc) greeter_compositor_accelerator_dup, (GBoxedFreeFunc) greeter_compositor_accelerator_free);
		g_once_init_leave (&greeter_compositor_accelerator_type_id__volatile, greeter_compositor_accelerator_type_id);
	}
	return greeter_compositor_accelerator_type_id__volatile;
}

GreeterCompositorGrabbedAccelerator*
greeter_compositor_grabbed_accelerator_new (void)
{
	GreeterCompositorGrabbedAccelerator* self;
#line 51 "../compositor/DBusAccelerator.vala"
	self = g_slice_new0 (GreeterCompositorGrabbedAccelerator);
#line 51 "../compositor/DBusAccelerator.vala"
	greeter_compositor_grabbed_accelerator_instance_init (self);
#line 51 "../compositor/DBusAccelerator.vala"
	return self;
#line 356 "DBusAccelerator.c"
}

static void
greeter_compositor_grabbed_accelerator_instance_init (GreeterCompositorGrabbedAccelerator * self)
{
}

void
greeter_compositor_grabbed_accelerator_free (GreeterCompositorGrabbedAccelerator * self)
{
#line 52 "../compositor/DBusAccelerator.vala"
	greeter_compositor_accelerator_destroy (&self->accelerator);
#line 51 "../compositor/DBusAccelerator.vala"
	g_slice_free (GreeterCompositorGrabbedAccelerator, self);
#line 371 "DBusAccelerator.c"
}

static inline gpointer
greeter_compositor_dbus_accelerator_get_instance_private (GreeterCompositorDBusAccelerator* self)
{
	return G_STRUCT_MEMBER_P (self, GreeterCompositorDBusAccelerator_private_offset);
}

static void
_greeter_compositor_grabbed_accelerator_free0_ (gpointer var)
{
#line 71 "../compositor/DBusAccelerator.vala"
	(var == NULL) ? NULL : (var = (greeter_compositor_grabbed_accelerator_free (var), NULL));
#line 385 "DBusAccelerator.c"
}

static inline void
_g_list_free__greeter_compositor_grabbed_accelerator_free0_ (GList* self)
{
#line 71 "../compositor/DBusAccelerator.vala"
	g_list_free_full (self, (GDestroyNotify) _greeter_compositor_grabbed_accelerator_free0_);
#line 393 "DBusAccelerator.c"
}

GreeterCompositorDBusAccelerator*
greeter_compositor_dbus_accelerator_init (GreeterCompositorWindowManager* wm)
{
	GreeterCompositorDBusAccelerator* _tmp0_;
	GreeterCompositorDBusAccelerator* _tmp2_;
	GreeterCompositorDBusAccelerator* result = NULL;
#line 61 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 62 "../compositor/DBusAccelerator.vala"
	_tmp0_ = greeter_compositor_dbus_accelerator_instance;
#line 62 "../compositor/DBusAccelerator.vala"
	if (_tmp0_ == NULL) {
#line 408 "DBusAccelerator.c"
		GreeterCompositorDBusAccelerator* _tmp1_;
#line 63 "../compositor/DBusAccelerator.vala"
		_tmp1_ = greeter_compositor_dbus_accelerator_new (wm);
#line 63 "../compositor/DBusAccelerator.vala"
		_greeter_compositor_dbus_accelerator_unref0 (greeter_compositor_dbus_accelerator_instance);
#line 63 "../compositor/DBusAccelerator.vala"
		greeter_compositor_dbus_accelerator_instance = _tmp1_;
#line 416 "DBusAccelerator.c"
	}
#line 65 "../compositor/DBusAccelerator.vala"
	_tmp2_ = greeter_compositor_dbus_accelerator_instance;
#line 65 "../compositor/DBusAccelerator.vala"
	result = _tmp2_;
#line 65 "../compositor/DBusAccelerator.vala"
	return result;
#line 424 "DBusAccelerator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "../compositor/DBusAccelerator.vala"
	return self ? g_object_ref (self) : NULL;
#line 432 "DBusAccelerator.c"
}

static void
_greeter_compositor_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                                  guint object,
                                                                                                  guint p0,
                                                                                                  guint p1,
                                                                                                  gpointer self)
{
#line 77 "../compositor/DBusAccelerator.vala"
	greeter_compositor_dbus_accelerator_on_accelerator_activated ((GreeterCompositorDBusAccelerator*) self, object, p0, p1);
#line 444 "DBusAccelerator.c"
}

static GreeterCompositorDBusAccelerator*
greeter_compositor_dbus_accelerator_construct (GType object_type,
                                               GreeterCompositorWindowManager* _wm)
{
	GreeterCompositorDBusAccelerator* self = NULL;
	GreeterCompositorWindowManager* _tmp0_;
	GreeterCompositorWindowManager* _tmp1_;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
#line 73 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (_wm != NULL, NULL);
#line 73 "../compositor/DBusAccelerator.vala"
	self = (GreeterCompositorDBusAccelerator*) g_type_create_instance (object_type);
#line 74 "../compositor/DBusAccelerator.vala"
	_tmp0_ = _g_object_ref0 (_wm);
#line 74 "../compositor/DBusAccelerator.vala"
	_g_object_unref0 (self->priv->wm);
#line 74 "../compositor/DBusAccelerator.vala"
	self->priv->wm = _tmp0_;
#line 75 "../compositor/DBusAccelerator.vala"
	(self->priv->grabbed_accelerators == NULL) ? NULL : (self->priv->grabbed_accelerators = (_g_list_free__greeter_compositor_grabbed_accelerator_free0_ (self->priv->grabbed_accelerators), NULL));
#line 75 "../compositor/DBusAccelerator.vala"
	self->priv->grabbed_accelerators = NULL;
#line 77 "../compositor/DBusAccelerator.vala"
	_tmp1_ = self->priv->wm;
#line 77 "../compositor/DBusAccelerator.vala"
	_tmp2_ = meta_plugin_get_screen ((MetaPlugin*) _tmp1_);
#line 77 "../compositor/DBusAccelerator.vala"
	_tmp3_ = meta_screen_get_display (_tmp2_);
#line 77 "../compositor/DBusAccelerator.vala"
	g_signal_connect (_tmp3_, "accelerator-activated", (GCallback) _greeter_compositor_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated, self);
#line 73 "../compositor/DBusAccelerator.vala"
	return self;
#line 480 "DBusAccelerator.c"
}

static GreeterCompositorDBusAccelerator*
greeter_compositor_dbus_accelerator_new (GreeterCompositorWindowManager* _wm)
{
#line 73 "../compositor/DBusAccelerator.vala"
	return greeter_compositor_dbus_accelerator_construct (GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR, _wm);
#line 488 "DBusAccelerator.c"
}

static void
_g_free0_ (gpointer var)
{
#line 84 "../compositor/DBusAccelerator.vala"
	var = (g_free (var), NULL);
#line 496 "DBusAccelerator.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 84 "../compositor/DBusAccelerator.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 504 "DBusAccelerator.c"
}

static void
greeter_compositor_dbus_accelerator_on_accelerator_activated (GreeterCompositorDBusAccelerator* self,
                                                              guint action,
                                                              guint device_id,
                                                              guint timestamp)
{
	GList* _tmp0_;
#line 80 "../compositor/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 81 "../compositor/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 518 "DBusAccelerator.c"
	{
		GList* accel_collection = NULL;
		GList* accel_it = NULL;
#line 81 "../compositor/DBusAccelerator.vala"
		accel_collection = _tmp0_;
#line 81 "../compositor/DBusAccelerator.vala"
		for (accel_it = accel_collection; accel_it != NULL; accel_it = accel_it->next) {
#line 526 "DBusAccelerator.c"
			GreeterCompositorGrabbedAccelerator* accel = NULL;
#line 81 "../compositor/DBusAccelerator.vala"
			accel = (GreeterCompositorGrabbedAccelerator*) accel_it->data;
#line 530 "DBusAccelerator.c"
			{
				GreeterCompositorGrabbedAccelerator* _tmp1_;
#line 82 "../compositor/DBusAccelerator.vala"
				_tmp1_ = accel;
#line 82 "../compositor/DBusAccelerator.vala"
				if (_tmp1_->action == action) {
#line 537 "DBusAccelerator.c"
					GreeterCompositorGrabbedAccelerator* _tmp2_;
					GreeterCompositorAccelerator _tmp3_;
					GreeterCompositorActionMode _tmp4_;
#line 83 "../compositor/DBusAccelerator.vala"
					_tmp2_ = accel;
#line 83 "../compositor/DBusAccelerator.vala"
					_tmp3_ = _tmp2_->accelerator;
#line 83 "../compositor/DBusAccelerator.vala"
					_tmp4_ = _tmp3_.flags;
#line 83 "../compositor/DBusAccelerator.vala"
					if ((_tmp4_ & GREETER_COMPOSITOR_ACTION_MODE_LOGIN_SCREEN) == GREETER_COMPOSITOR_ACTION_MODE_LOGIN_SCREEN) {
#line 549 "DBusAccelerator.c"
						GHashTable* parameters = NULL;
						GHashTable* _tmp5_;
						GHashTable* _tmp6_;
						gchar* _tmp7_;
						GVariant* _tmp8_;
						GHashTable* _tmp9_;
						gchar* _tmp10_;
						GVariant* _tmp11_;
						GHashTable* _tmp12_;
#line 84 "../compositor/DBusAccelerator.vala"
						_tmp5_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
#line 84 "../compositor/DBusAccelerator.vala"
						parameters = _tmp5_;
#line 85 "../compositor/DBusAccelerator.vala"
						_tmp6_ = parameters;
#line 85 "../compositor/DBusAccelerator.vala"
						_tmp7_ = g_strdup ("device-id");
#line 85 "../compositor/DBusAccelerator.vala"
						_tmp8_ = g_variant_new_uint32 ((guint32) device_id);
#line 85 "../compositor/DBusAccelerator.vala"
						g_variant_ref_sink (_tmp8_);
#line 85 "../compositor/DBusAccelerator.vala"
						g_hash_table_insert (_tmp6_, _tmp7_, _tmp8_);
#line 86 "../compositor/DBusAccelerator.vala"
						_tmp9_ = parameters;
#line 86 "../compositor/DBusAccelerator.vala"
						_tmp10_ = g_strdup ("timestamp");
#line 86 "../compositor/DBusAccelerator.vala"
						_tmp11_ = g_variant_new_uint32 ((guint32) timestamp);
#line 86 "../compositor/DBusAccelerator.vala"
						g_variant_ref_sink (_tmp11_);
#line 86 "../compositor/DBusAccelerator.vala"
						g_hash_table_insert (_tmp9_, _tmp10_, _tmp11_);
#line 88 "../compositor/DBusAccelerator.vala"
						_tmp12_ = parameters;
#line 88 "../compositor/DBusAccelerator.vala"
						g_signal_emit (self, greeter_compositor_dbus_accelerator_signals[GREETER_COMPOSITOR_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL], 0, action, _tmp12_);
#line 83 "../compositor/DBusAccelerator.vala"
						_g_hash_table_unref0 (parameters);
#line 589 "DBusAccelerator.c"
					}
#line 91 "../compositor/DBusAccelerator.vala"
					return;
#line 593 "DBusAccelerator.c"
				}
			}
		}
	}
}

static guint
greeter_compositor_dbus_accelerator_grab_accelerator (GreeterCompositorDBusAccelerator* self,
                                                      GreeterCompositorAccelerator* accelerator)
{
	GList* _tmp0_;
	guint action = 0U;
	GreeterCompositorWindowManager* _tmp7_;
	MetaScreen* _tmp8_;
	MetaDisplay* _tmp9_;
	GreeterCompositorAccelerator _tmp10_;
	const gchar* _tmp11_;
	guint result = 0U;
#line 96 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 96 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (accelerator != NULL, 0U);
#line 97 "../compositor/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 618 "DBusAccelerator.c"
	{
		GList* accel_collection = NULL;
		GList* accel_it = NULL;
#line 97 "../compositor/DBusAccelerator.vala"
		accel_collection = _tmp0_;
#line 97 "../compositor/DBusAccelerator.vala"
		for (accel_it = accel_collection; accel_it != NULL; accel_it = accel_it->next) {
#line 626 "DBusAccelerator.c"
			GreeterCompositorGrabbedAccelerator* accel = NULL;
#line 97 "../compositor/DBusAccelerator.vala"
			accel = (GreeterCompositorGrabbedAccelerator*) accel_it->data;
#line 630 "DBusAccelerator.c"
			{
				GreeterCompositorGrabbedAccelerator* _tmp1_;
				GreeterCompositorAccelerator _tmp2_;
				const gchar* _tmp3_;
				GreeterCompositorAccelerator _tmp4_;
				const gchar* _tmp5_;
#line 98 "../compositor/DBusAccelerator.vala"
				_tmp1_ = accel;
#line 98 "../compositor/DBusAccelerator.vala"
				_tmp2_ = _tmp1_->accelerator;
#line 98 "../compositor/DBusAccelerator.vala"
				_tmp3_ = _tmp2_.name;
#line 98 "../compositor/DBusAccelerator.vala"
				_tmp4_ = *accelerator;
#line 98 "../compositor/DBusAccelerator.vala"
				_tmp5_ = _tmp4_.name;
#line 98 "../compositor/DBusAccelerator.vala"
				if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 649 "DBusAccelerator.c"
					GreeterCompositorGrabbedAccelerator* _tmp6_;
#line 99 "../compositor/DBusAccelerator.vala"
					_tmp6_ = accel;
#line 99 "../compositor/DBusAccelerator.vala"
					result = _tmp6_->action;
#line 99 "../compositor/DBusAccelerator.vala"
					return result;
#line 657 "DBusAccelerator.c"
				}
			}
		}
	}
#line 103 "../compositor/DBusAccelerator.vala"
	_tmp7_ = self->priv->wm;
#line 103 "../compositor/DBusAccelerator.vala"
	_tmp8_ = meta_plugin_get_screen ((MetaPlugin*) _tmp7_);
#line 103 "../compositor/DBusAccelerator.vala"
	_tmp9_ = meta_screen_get_display (_tmp8_);
#line 103 "../compositor/DBusAccelerator.vala"
	_tmp10_ = *accelerator;
#line 103 "../compositor/DBusAccelerator.vala"
	_tmp11_ = _tmp10_.name;
#line 103 "../compositor/DBusAccelerator.vala"
	action = meta_display_grab_accelerator (_tmp9_, _tmp11_);
#line 104 "../compositor/DBusAccelerator.vala"
	if (action > ((guint) 0)) {
#line 676 "DBusAccelerator.c"
		GreeterCompositorGrabbedAccelerator* accel = NULL;
		GreeterCompositorGrabbedAccelerator* _tmp12_;
		GreeterCompositorGrabbedAccelerator* _tmp13_;
		GreeterCompositorGrabbedAccelerator* _tmp14_;
		GreeterCompositorAccelerator _tmp15_;
		GreeterCompositorAccelerator _tmp16_;
		GreeterCompositorAccelerator _tmp17_ = {0};
		GreeterCompositorGrabbedAccelerator* _tmp18_;
#line 105 "../compositor/DBusAccelerator.vala"
		_tmp12_ = greeter_compositor_grabbed_accelerator_new ();
#line 105 "../compositor/DBusAccelerator.vala"
		accel = _tmp12_;
#line 106 "../compositor/DBusAccelerator.vala"
		_tmp13_ = accel;
#line 106 "../compositor/DBusAccelerator.vala"
		_tmp13_->action = action;
#line 107 "../compositor/DBusAccelerator.vala"
		_tmp14_ = accel;
#line 107 "../compositor/DBusAccelerator.vala"
		_tmp15_ = *accelerator;
#line 107 "../compositor/DBusAccelerator.vala"
		_tmp16_ = _tmp15_;
#line 107 "../compositor/DBusAccelerator.vala"
		greeter_compositor_accelerator_copy (&_tmp16_, &_tmp17_);
#line 107 "../compositor/DBusAccelerator.vala"
		greeter_compositor_accelerator_destroy (&_tmp14_->accelerator);
#line 107 "../compositor/DBusAccelerator.vala"
		_tmp14_->accelerator = _tmp17_;
#line 108 "../compositor/DBusAccelerator.vala"
		_tmp18_ = accel;
#line 108 "../compositor/DBusAccelerator.vala"
		accel = NULL;
#line 108 "../compositor/DBusAccelerator.vala"
		self->priv->grabbed_accelerators = g_list_append (self->priv->grabbed_accelerators, _tmp18_);
#line 104 "../compositor/DBusAccelerator.vala"
		_greeter_compositor_grabbed_accelerator_free0 (accel);
#line 713 "DBusAccelerator.c"
	}
#line 111 "../compositor/DBusAccelerator.vala"
	result = action;
#line 111 "../compositor/DBusAccelerator.vala"
	return result;
#line 719 "DBusAccelerator.c"
}

static void
_vala_array_add1 (guint* * array,
                  int* length,
                  int* size,
                  guint value)
{
#line 118 "../compositor/DBusAccelerator.vala"
	if ((*length) == (*size)) {
#line 118 "../compositor/DBusAccelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 118 "../compositor/DBusAccelerator.vala"
		*array = g_renew (guint, *array, *size);
#line 734 "DBusAccelerator.c"
	}
#line 118 "../compositor/DBusAccelerator.vala"
	(*array)[(*length)++] = value;
#line 738 "DBusAccelerator.c"
}

guint*
greeter_compositor_dbus_accelerator_grab_accelerators (GreeterCompositorDBusAccelerator* self,
                                                       GreeterCompositorAccelerator* accelerators,
                                                       gint accelerators_length1,
                                                       gint* result_length1,
                                                       GError** error)
{
	guint* actions = NULL;
	guint* _tmp0_;
	gint actions_length1;
	gint _actions_size_;
	guint* _tmp3_;
	gint _tmp3__length1;
	guint* result = NULL;
#line 114 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../compositor/DBusAccelerator.vala"
	_tmp0_ = g_new0 (guint, 0);
#line 115 "../compositor/DBusAccelerator.vala"
	actions = _tmp0_;
#line 115 "../compositor/DBusAccelerator.vala"
	actions_length1 = 0;
#line 115 "../compositor/DBusAccelerator.vala"
	_actions_size_ = actions_length1;
#line 765 "DBusAccelerator.c"
	{
		GreeterCompositorAccelerator* accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 117 "../compositor/DBusAccelerator.vala"
		accelerator_collection = accelerators;
#line 117 "../compositor/DBusAccelerator.vala"
		accelerator_collection_length1 = accelerators_length1;
#line 117 "../compositor/DBusAccelerator.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 777 "DBusAccelerator.c"
			GreeterCompositorAccelerator accelerator = {0};
#line 117 "../compositor/DBusAccelerator.vala"
			accelerator = accelerator_collection[accelerator_it];
#line 781 "DBusAccelerator.c"
			{
				guint* _tmp1_;
				gint _tmp1__length1;
				GreeterCompositorAccelerator _tmp2_;
#line 118 "../compositor/DBusAccelerator.vala"
				_tmp1_ = actions;
#line 118 "../compositor/DBusAccelerator.vala"
				_tmp1__length1 = actions_length1;
#line 118 "../compositor/DBusAccelerator.vala"
				_tmp2_ = accelerator;
#line 118 "../compositor/DBusAccelerator.vala"
				_vala_array_add1 (&actions, &actions_length1, &_actions_size_, greeter_compositor_dbus_accelerator_grab_accelerator (self, &_tmp2_));
#line 794 "DBusAccelerator.c"
			}
		}
	}
#line 121 "../compositor/DBusAccelerator.vala"
	_tmp3_ = actions;
#line 121 "../compositor/DBusAccelerator.vala"
	_tmp3__length1 = actions_length1;
#line 121 "../compositor/DBusAccelerator.vala"
	if (result_length1) {
#line 121 "../compositor/DBusAccelerator.vala"
		*result_length1 = _tmp3__length1;
#line 806 "DBusAccelerator.c"
	}
#line 121 "../compositor/DBusAccelerator.vala"
	result = _tmp3_;
#line 121 "../compositor/DBusAccelerator.vala"
	return result;
#line 812 "DBusAccelerator.c"
}

gboolean
greeter_compositor_dbus_accelerator_ungrab_accelerator (GreeterCompositorDBusAccelerator* self,
                                                        guint action,
                                                        GError** error)
{
	GList* _tmp0_;
	gboolean result = FALSE;
#line 124 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "../compositor/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 826 "DBusAccelerator.c"
	{
		GList* accel_collection = NULL;
		GList* accel_it = NULL;
#line 125 "../compositor/DBusAccelerator.vala"
		accel_collection = _tmp0_;
#line 125 "../compositor/DBusAccelerator.vala"
		for (accel_it = accel_collection; accel_it != NULL; accel_it = accel_it->next) {
#line 834 "DBusAccelerator.c"
			GreeterCompositorGrabbedAccelerator* accel = NULL;
#line 125 "../compositor/DBusAccelerator.vala"
			accel = (GreeterCompositorGrabbedAccelerator*) accel_it->data;
#line 838 "DBusAccelerator.c"
			{
				GreeterCompositorGrabbedAccelerator* _tmp1_;
#line 126 "../compositor/DBusAccelerator.vala"
				_tmp1_ = accel;
#line 126 "../compositor/DBusAccelerator.vala"
				if (_tmp1_->action == action) {
#line 845 "DBusAccelerator.c"
					gboolean ret = FALSE;
					GreeterCompositorWindowManager* _tmp2_;
					MetaScreen* _tmp3_;
					MetaDisplay* _tmp4_;
					GreeterCompositorGrabbedAccelerator* _tmp5_;
#line 127 "../compositor/DBusAccelerator.vala"
					_tmp2_ = self->priv->wm;
#line 127 "../compositor/DBusAccelerator.vala"
					_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
#line 127 "../compositor/DBusAccelerator.vala"
					_tmp4_ = meta_screen_get_display (_tmp3_);
#line 127 "../compositor/DBusAccelerator.vala"
					ret = meta_display_ungrab_accelerator (_tmp4_, action);
#line 128 "../compositor/DBusAccelerator.vala"
					_tmp5_ = accel;
#line 128 "../compositor/DBusAccelerator.vala"
					self->priv->grabbed_accelerators = g_list_remove (self->priv->grabbed_accelerators, _tmp5_);
#line 129 "../compositor/DBusAccelerator.vala"
					result = ret;
#line 129 "../compositor/DBusAccelerator.vala"
					return result;
#line 867 "DBusAccelerator.c"
				}
			}
		}
	}
#line 133 "../compositor/DBusAccelerator.vala"
	result = FALSE;
#line 133 "../compositor/DBusAccelerator.vala"
	return result;
#line 876 "DBusAccelerator.c"
}

void
greeter_compositor_dbus_accelerator_show_osd (GreeterCompositorDBusAccelerator* self,
                                              GHashTable* parameters,
                                              GError** error)
{
	gint32 monitor_index = 0;
	gchar* icon = NULL;
	gchar* _tmp1_;
	gchar* label = NULL;
	gchar* _tmp5_;
	gint32 level = 0;
	const gchar* _tmp10_;
#line 137 "../compositor/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 137 "../compositor/DBusAccelerator.vala"
	g_return_if_fail (parameters != NULL);
#line 138 "../compositor/DBusAccelerator.vala"
	monitor_index = (gint32) -1;
#line 139 "../compositor/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "monitor")) {
#line 899 "DBusAccelerator.c"
		gconstpointer _tmp0_;
#line 140 "../compositor/DBusAccelerator.vala"
		_tmp0_ = g_hash_table_lookup (parameters, "monitor");
#line 140 "../compositor/DBusAccelerator.vala"
		monitor_index = g_variant_get_int32 ((GVariant*) _tmp0_);
#line 905 "DBusAccelerator.c"
	}
#line 141 "../compositor/DBusAccelerator.vala"
	_tmp1_ = g_strdup ("");
#line 141 "../compositor/DBusAccelerator.vala"
	icon = _tmp1_;
#line 142 "../compositor/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "icon")) {
#line 913 "DBusAccelerator.c"
		gconstpointer _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 143 "../compositor/DBusAccelerator.vala"
		_tmp2_ = g_hash_table_lookup (parameters, "icon");
#line 143 "../compositor/DBusAccelerator.vala"
		_tmp3_ = g_variant_get_string ((GVariant*) _tmp2_, NULL);
#line 143 "../compositor/DBusAccelerator.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 143 "../compositor/DBusAccelerator.vala"
		_g_free0 (icon);
#line 143 "../compositor/DBusAccelerator.vala"
		icon = _tmp4_;
#line 927 "DBusAccelerator.c"
	}
#line 144 "../compositor/DBusAccelerator.vala"
	_tmp5_ = g_strdup ("");
#line 144 "../compositor/DBusAccelerator.vala"
	label = _tmp5_;
#line 145 "../compositor/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "label")) {
#line 935 "DBusAccelerator.c"
		gconstpointer _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 146 "../compositor/DBusAccelerator.vala"
		_tmp6_ = g_hash_table_lookup (parameters, "label");
#line 146 "../compositor/DBusAccelerator.vala"
		_tmp7_ = g_variant_get_string ((GVariant*) _tmp6_, NULL);
#line 146 "../compositor/DBusAccelerator.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 146 "../compositor/DBusAccelerator.vala"
		_g_free0 (label);
#line 146 "../compositor/DBusAccelerator.vala"
		label = _tmp8_;
#line 949 "DBusAccelerator.c"
	}
#line 147 "../compositor/DBusAccelerator.vala"
	level = (gint32) 0;
#line 148 "../compositor/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "level")) {
#line 955 "DBusAccelerator.c"
		gconstpointer _tmp9_;
#line 149 "../compositor/DBusAccelerator.vala"
		_tmp9_ = g_hash_table_lookup (parameters, "level");
#line 149 "../compositor/DBusAccelerator.vala"
		level = g_variant_get_int32 ((GVariant*) _tmp9_);
#line 961 "DBusAccelerator.c"
	}
#line 151 "../compositor/DBusAccelerator.vala"
	_tmp10_ = icon;
#line 151 "../compositor/DBusAccelerator.vala"
	greeter_compositor_media_feedback_send (_tmp10_, (gint) level);
#line 137 "../compositor/DBusAccelerator.vala"
	_g_free0 (label);
#line 137 "../compositor/DBusAccelerator.vala"
	_g_free0 (icon);
#line 971 "DBusAccelerator.c"
}

static void
g_cclosure_user_marshal_VOID__UINT_BOXED (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_BOXED) (gpointer data1, guint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 57 "../compositor/DBusAccelerator.vala"
	g_return_if_fail (n_param_values == 3);
#line 57 "../compositor/DBusAccelerator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 57 "../compositor/DBusAccelerator.vala"
		data1 = closure->data;
#line 57 "../compositor/DBusAccelerator.vala"
		data2 = param_values->data[0].v_pointer;
#line 996 "DBusAccelerator.c"
	} else {
#line 57 "../compositor/DBusAccelerator.vala"
		data1 = param_values->data[0].v_pointer;
#line 57 "../compositor/DBusAccelerator.vala"
		data2 = closure->data;
#line 1002 "DBusAccelerator.c"
	}
#line 57 "../compositor/DBusAccelerator.vala"
	callback = (GMarshalFunc_VOID__UINT_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 57 "../compositor/DBusAccelerator.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 1008 "DBusAccelerator.c"
}

static void
greeter_compositor_value_dbus_accelerator_init (GValue* value)
{
#line 57 "../compositor/DBusAccelerator.vala"
	value->data[0].v_pointer = NULL;
#line 1016 "DBusAccelerator.c"
}

static void
greeter_compositor_value_dbus_accelerator_free_value (GValue* value)
{
#line 57 "../compositor/DBusAccelerator.vala"
	if (value->data[0].v_pointer) {
#line 57 "../compositor/DBusAccelerator.vala"
		greeter_compositor_dbus_accelerator_unref (value->data[0].v_pointer);
#line 1026 "DBusAccelerator.c"
	}
}

static void
greeter_compositor_value_dbus_accelerator_copy_value (const GValue* src_value,
                                                      GValue* dest_value)
{
#line 57 "../compositor/DBusAccelerator.vala"
	if (src_value->data[0].v_pointer) {
#line 57 "../compositor/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = greeter_compositor_dbus_accelerator_ref (src_value->data[0].v_pointer);
#line 1038 "DBusAccelerator.c"
	} else {
#line 57 "../compositor/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1042 "DBusAccelerator.c"
	}
}

static gpointer
greeter_compositor_value_dbus_accelerator_peek_pointer (const GValue* value)
{
#line 57 "../compositor/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1051 "DBusAccelerator.c"
}

static gchar*
greeter_compositor_value_dbus_accelerator_collect_value (GValue* value,
                                                         guint n_collect_values,
                                                         GTypeCValue* collect_values,
                                                         guint collect_flags)
{
#line 57 "../compositor/DBusAccelerator.vala"
	if (collect_values[0].v_pointer) {
#line 1062 "DBusAccelerator.c"
		GreeterCompositorDBusAccelerator * object;
		object = collect_values[0].v_pointer;
#line 57 "../compositor/DBusAccelerator.vala"
		if (object->parent_instance.g_class == NULL) {
#line 57 "../compositor/DBusAccelerator.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1069 "DBusAccelerator.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 57 "../compositor/DBusAccelerator.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1073 "DBusAccelerator.c"
		}
#line 57 "../compositor/DBusAccelerator.vala"
		value->data[0].v_pointer = greeter_compositor_dbus_accelerator_ref (object);
#line 1077 "DBusAccelerator.c"
	} else {
#line 57 "../compositor/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1081 "DBusAccelerator.c"
	}
#line 57 "../compositor/DBusAccelerator.vala"
	return NULL;
#line 1085 "DBusAccelerator.c"
}

static gchar*
greeter_compositor_value_dbus_accelerator_lcopy_value (const GValue* value,
                                                       guint n_collect_values,
                                                       GTypeCValue* collect_values,
                                                       guint collect_flags)
{
	GreeterCompositorDBusAccelerator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 57 "../compositor/DBusAccelerator.vala"
	if (!object_p) {
#line 57 "../compositor/DBusAccelerator.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1100 "DBusAccelerator.c"
	}
#line 57 "../compositor/DBusAccelerator.vala"
	if (!value->data[0].v_pointer) {
#line 57 "../compositor/DBusAccelerator.vala"
		*object_p = NULL;
#line 1106 "DBusAccelerator.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 57 "../compositor/DBusAccelerator.vala"
		*object_p = value->data[0].v_pointer;
#line 1110 "DBusAccelerator.c"
	} else {
#line 57 "../compositor/DBusAccelerator.vala"
		*object_p = greeter_compositor_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1114 "DBusAccelerator.c"
	}
#line 57 "../compositor/DBusAccelerator.vala"
	return NULL;
#line 1118 "DBusAccelerator.c"
}

GParamSpec*
greeter_compositor_param_spec_dbus_accelerator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags)
{
	GreeterCompositorParamSpecDBusAccelerator* spec;
#line 57 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR), NULL);
#line 57 "../compositor/DBusAccelerator.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 57 "../compositor/DBusAccelerator.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 57 "../compositor/DBusAccelerator.vala"
	return G_PARAM_SPEC (spec);
#line 1137 "DBusAccelerator.c"
}

gpointer
greeter_compositor_value_get_dbus_accelerator (const GValue* value)
{
#line 57 "../compositor/DBusAccelerator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR), NULL);
#line 57 "../compositor/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1147 "DBusAccelerator.c"
}

void
greeter_compositor_value_set_dbus_accelerator (GValue* value,
                                               gpointer v_object)
{
	GreeterCompositorDBusAccelerator * old;
#line 57 "../compositor/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR));
#line 57 "../compositor/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 57 "../compositor/DBusAccelerator.vala"
	if (v_object) {
#line 57 "../compositor/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR));
#line 57 "../compositor/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 57 "../compositor/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 57 "../compositor/DBusAccelerator.vala"
		greeter_compositor_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1169 "DBusAccelerator.c"
	} else {
#line 57 "../compositor/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1173 "DBusAccelerator.c"
	}
#line 57 "../compositor/DBusAccelerator.vala"
	if (old) {
#line 57 "../compositor/DBusAccelerator.vala"
		greeter_compositor_dbus_accelerator_unref (old);
#line 1179 "DBusAccelerator.c"
	}
}

void
greeter_compositor_value_take_dbus_accelerator (GValue* value,
                                                gpointer v_object)
{
	GreeterCompositorDBusAccelerator * old;
#line 57 "../compositor/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR));
#line 57 "../compositor/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 57 "../compositor/DBusAccelerator.vala"
	if (v_object) {
#line 57 "../compositor/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR));
#line 57 "../compositor/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 57 "../compositor/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 1200 "DBusAccelerator.c"
	} else {
#line 57 "../compositor/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1204 "DBusAccelerator.c"
	}
#line 57 "../compositor/DBusAccelerator.vala"
	if (old) {
#line 57 "../compositor/DBusAccelerator.vala"
		greeter_compositor_dbus_accelerator_unref (old);
#line 1210 "DBusAccelerator.c"
	}
}

static void
greeter_compositor_dbus_accelerator_class_init (GreeterCompositorDBusAcceleratorClass * klass,
                                                gpointer klass_data)
{
#line 57 "../compositor/DBusAccelerator.vala"
	greeter_compositor_dbus_accelerator_parent_class = g_type_class_peek_parent (klass);
#line 57 "../compositor/DBusAccelerator.vala"
	((GreeterCompositorDBusAcceleratorClass *) klass)->finalize = greeter_compositor_dbus_accelerator_finalize;
#line 57 "../compositor/DBusAccelerator.vala"
	g_type_class_adjust_private_offset (klass, &GreeterCompositorDBusAccelerator_private_offset);
#line 57 "../compositor/DBusAccelerator.vala"
	greeter_compositor_dbus_accelerator_signals[GREETER_COMPOSITOR_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL] = g_signal_new ("accelerator-activated", GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_BOXED, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_HASH_TABLE);
#line 1226 "DBusAccelerator.c"
}

static void
greeter_compositor_dbus_accelerator_instance_init (GreeterCompositorDBusAccelerator * self,
                                                   gpointer klass)
{
#line 57 "../compositor/DBusAccelerator.vala"
	self->priv = greeter_compositor_dbus_accelerator_get_instance_private (self);
#line 57 "../compositor/DBusAccelerator.vala"
	self->ref_count = 1;
#line 1237 "DBusAccelerator.c"
}

static void
greeter_compositor_dbus_accelerator_finalize (GreeterCompositorDBusAccelerator * obj)
{
	GreeterCompositorDBusAccelerator * self;
#line 57 "../compositor/DBusAccelerator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_COMPOSITOR_TYPE_DBUS_ACCELERATOR, GreeterCompositorDBusAccelerator);
#line 57 "../compositor/DBusAccelerator.vala"
	g_signal_handlers_destroy (self);
#line 70 "../compositor/DBusAccelerator.vala"
	_g_object_unref0 (self->priv->wm);
#line 71 "../compositor/DBusAccelerator.vala"
	(self->priv->grabbed_accelerators == NULL) ? NULL : (self->priv->grabbed_accelerators = (_g_list_free__greeter_compositor_grabbed_accelerator_free0_ (self->priv->grabbed_accelerators), NULL));
#line 1252 "DBusAccelerator.c"
}

GType
greeter_compositor_dbus_accelerator_get_type (void)
{
	static volatile gsize greeter_compositor_dbus_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&greeter_compositor_dbus_accelerator_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { greeter_compositor_value_dbus_accelerator_init, greeter_compositor_value_dbus_accelerator_free_value, greeter_compositor_value_dbus_accelerator_copy_value, greeter_compositor_value_dbus_accelerator_peek_pointer, "p", greeter_compositor_value_dbus_accelerator_collect_value, "p", greeter_compositor_value_dbus_accelerator_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GreeterCompositorDBusAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_compositor_dbus_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterCompositorDBusAccelerator), 0, (GInstanceInitFunc) greeter_compositor_dbus_accelerator_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType greeter_compositor_dbus_accelerator_type_id;
		greeter_compositor_dbus_accelerator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GreeterCompositorDBusAccelerator", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_type_set_qdata (greeter_compositor_dbus_accelerator_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) greeter_compositor_dbus_accelerator_register_object);
		GreeterCompositorDBusAccelerator_private_offset = g_type_add_instance_private (greeter_compositor_dbus_accelerator_type_id, sizeof (GreeterCompositorDBusAcceleratorPrivate));
		g_once_init_leave (&greeter_compositor_dbus_accelerator_type_id__volatile, greeter_compositor_dbus_accelerator_type_id);
	}
	return greeter_compositor_dbus_accelerator_type_id__volatile;
}

gpointer
greeter_compositor_dbus_accelerator_ref (gpointer instance)
{
	GreeterCompositorDBusAccelerator * self;
	self = instance;
#line 57 "../compositor/DBusAccelerator.vala"
	g_atomic_int_inc (&self->ref_count);
#line 57 "../compositor/DBusAccelerator.vala"
	return instance;
#line 1281 "DBusAccelerator.c"
}

void
greeter_compositor_dbus_accelerator_unref (gpointer instance)
{
	GreeterCompositorDBusAccelerator * self;
	self = instance;
#line 57 "../compositor/DBusAccelerator.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 57 "../compositor/DBusAccelerator.vala"
		GREETER_COMPOSITOR_DBUS_ACCELERATOR_GET_CLASS (self)->finalize (self);
#line 57 "../compositor/DBusAccelerator.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1295 "DBusAccelerator.c"
	}
}

static void
_vala_GreeterCompositorAccelerator_array_free (GreeterCompositorAccelerator * array,
                                               gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			greeter_compositor_accelerator_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_greeter_compositor_dbus_accelerator_grab_accelerators (GreeterCompositorDBusAccelerator* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GreeterCompositorAccelerator* accelerators = NULL;
	gint accelerators_length1 = 0;
	GVariant* _tmp26_;
	GreeterCompositorAccelerator* _tmp27_;
	gint _tmp27__length;
	gint _tmp27__size;
	gint _tmp27__length1;
	GVariantIter _tmp28_;
	GVariant* _tmp29_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* result;
	gint result_length1 = 0;
	guint* _tmp34_;
	GVariantBuilder _tmp35_;
	gint _tmp36_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp26_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp27_ = g_new (GreeterCompositorAccelerator, 5);
	_tmp27__length = 0;
	_tmp27__size = 4;
	_tmp27__length1 = 0;
	g_variant_iter_init (&_tmp28_, _tmp26_);
	for (; (_tmp29_ = g_variant_iter_next_value (&_tmp28_)) != NULL; _tmp27__length1++) {
		GreeterCompositorAccelerator _tmp30_;
		GVariantIter _tmp31_;
		GVariant* _tmp32_;
		GVariant* _tmp33_;
		if (_tmp27__size == _tmp27__length) {
			_tmp27__size = 2 * _tmp27__size;
			_tmp27_ = g_renew (GreeterCompositorAccelerator, _tmp27_, _tmp27__size + 1);
		}
		g_variant_iter_init (&_tmp31_, _tmp29_);
		_tmp32_ = g_variant_iter_next_value (&_tmp31_);
		_tmp30_.name = g_variant_dup_string (_tmp32_, NULL);
		g_variant_unref (_tmp32_);
		_tmp33_ = g_variant_iter_next_value (&_tmp31_);
		_tmp30_.flags = g_variant_get_uint32 (_tmp33_);
		g_variant_unref (_tmp33_);
		_tmp27_[_tmp27__length++] = _tmp30_;
		g_variant_unref (_tmp29_);
	}
	accelerators_length1 = _tmp27__length1;
	accelerators = _tmp27_;
	g_variant_unref (_tmp26_);
	result = greeter_compositor_dbus_accelerator_grab_accelerators (self, accelerators, accelerators_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp34_ = result;
	g_variant_builder_init (&_tmp35_, G_VARIANT_TYPE ("au"));
	for (_tmp36_ = 0; _tmp36_ < result_length1; _tmp36_++) {
		g_variant_builder_add_value (&_tmp35_, g_variant_new_uint32 (*_tmp34_));
		_tmp34_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp35_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	accelerators = (_vala_GreeterCompositorAccelerator_array_free (accelerators, accelerators_length1), NULL);
}

static void
_dbus_greeter_compositor_dbus_accelerator_ungrab_accelerator (GreeterCompositorDBusAccelerator* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint action = 0U;
	GVariant* _tmp37_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp37_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_get_uint32 (_tmp37_);
	g_variant_unref (_tmp37_);
	result = greeter_compositor_dbus_accelerator_ungrab_accelerator (self, action, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_greeter_compositor_dbus_accelerator_show_osd (GreeterCompositorDBusAccelerator* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* parameters = NULL;
	GVariant* _tmp38_;
	GHashTable* _tmp39_;
	GVariantIter _tmp40_;
	GVariant* _tmp41_;
	GVariant* _tmp42_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp38_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp39_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp40_, _tmp38_);
	while (g_variant_iter_loop (&_tmp40_, "{?*}", &_tmp41_, &_tmp42_)) {
		g_hash_table_insert (_tmp39_, g_variant_dup_string (_tmp41_, NULL), g_variant_get_variant (_tmp42_));
	}
	parameters = _tmp39_;
	g_variant_unref (_tmp38_);
	greeter_compositor_dbus_accelerator_show_osd (self, parameters, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_hash_table_unref0 (parameters);
}

static void
greeter_compositor_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* method_name,
                                                                GVariant* parameters,
                                                                GDBusMethodInvocation* invocation,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GrabAccelerators") == 0) {
		_dbus_greeter_compositor_dbus_accelerator_grab_accelerators (object, parameters, invocation);
	} else if (strcmp (method_name, "UngrabAccelerator") == 0) {
		_dbus_greeter_compositor_dbus_accelerator_ungrab_accelerator (object, parameters, invocation);
	} else if (strcmp (method_name, "ShowOSD") == 0) {
		_dbus_greeter_compositor_dbus_accelerator_show_osd (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
greeter_compositor_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* property_name,
                                                                 GError** error,
                                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
greeter_compositor_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* property_name,
                                                                 GVariant* value,
                                                                 GError** error,
                                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_greeter_compositor_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                                 guint action,
                                                                 GHashTable* parameters,
                                                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp43_;
	GHashTableIter _tmp44_;
	gpointer _tmp45_;
	gpointer _tmp46_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action));
	g_hash_table_iter_init (&_tmp44_, parameters);
	g_variant_builder_init (&_tmp43_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp44_, &_tmp45_, &_tmp46_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp45_;
		_value = (GVariant*) _tmp46_;
		g_variant_builder_add (&_tmp43_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp43_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.Shell", "AcceleratorActivated", _arguments, NULL);
}

guint
greeter_compositor_dbus_accelerator_register_object (gpointer object,
                                                     GDBusConnection* connection,
                                                     const gchar* path,
                                                     GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = greeter_compositor_dbus_accelerator_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_greeter_compositor_dbus_accelerator_dbus_interface_info), &_greeter_compositor_dbus_accelerator_dbus_interface_vtable, data, _greeter_compositor_dbus_accelerator_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "accelerator-activated", (GCallback) _dbus_greeter_compositor_dbus_accelerator_accelerator_activated, data);
	return result;
}

static void
_greeter_compositor_dbus_accelerator_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_greeter_compositor_dbus_accelerator_accelerator_activated, data);
	greeter_compositor_dbus_accelerator_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

